<?php
function pulisci($dati){
	//da usare nel caso di possibile malfuzionamento di un sensore che non trasmette uno o pi dati
	//prima di calcolare la media e la deviazione standard
	if(is_array($dati)){//verifico che sia un array
		$dati_puliti=array();
		$n=count($dati);//conto i dati
		//verifico che il sensore non abbia trasmesso una o pi porcheria, eventualmente elimino
		for($k=0;$k < $n; $k++){
		///preg_match( '/^[\-+]?[0-9]*\.*\,?[0-9]+$/', $dati[$k])
			if(preg_match( '/^[\-+]?[0-9]*\.*\,?[0-9]+$/', $dati[$k])){$dati_puliti[]=$dati[$k];}//se non  un numero float salto il valore
		}
		if(is_array($dati_puliti)){//verifico che sia un array, quindi se contiene almeno un float
			return $dati_puliti;//c' almeno un dato float
		}else{
			return NULL;//ritorno il valore null in quanto non  un array
		}
	}else{
		return NULL;//ritorno il valore null in quanto non  un array
	}
}

function media($dati, $precisione){//array dei dati e precisione
	//con questa funzione devi usare i dati RIPULITI
	if(is_array($dati)){//verifico che sia un array, ridondante ma sempre meglio una verifica in pi
		$n=count($dati);//conto i valori dell'array
		$n=count($dati);//riconto i dati dopo la pulizia
		if(is_array($dati) && $n > 0){
			return round(array_sum($dati)/$n,$precisione);//se ok ritorno il valore medio
		}else{
			return NULL;//altrimenti NULL
		}
	}else{
		return NULL;
	}
}

function deviazione_standard($dati, $media, $precisione){//arry dei dati, valore medio e precisione
	//con questa funzione devi usare i dati RIPULITI
	//attenzione devo avere almeno due dati
	//da considerare che per pochi dati non ha molto significato
	if(is_array($dati)){//verifico che sia un array, ridondante ma sempre meglio una verifica in pi
		$quadrati = 0.0;
		foreach ($dati as $i){
        	$quadrati += pow($i - $media, 2);//calcolo la somma dei quadrati
    	}
		if(count($dati)>1){
			$varianza = $quadrati/(count($dati) - 1);//calcolo la varianza campionaria
			return round(sqrt($varianza),$precisione);//ritorno la dev. standard
		}else{
			return 0.0;//ritorno il valore zero
		}
	}else{
		return NULL;//altrimenti NULL
	}
}

function intervallo95($dati, $dev_st, $precisione){
	//il valore di questa funzione  valido con un grado di sicurezza del 95%
	//quando il numero dei dati  superiore a 30, per numeri inferiori sarebbe troppo complesso svilupparla
	//quindi con numero dati minori di 30 pu essere fuorviante - il fattore sarebbe da calcolare
	//con questa funzione devi usare i dati RIPULITI
	if(is_array($dati)){
		$n=count($dati);
		if($n > 2 && $n < 30){
			$f=4.0;
		}elseif($n >=30){
			$f=3.0;
		}else{
			return 0.0;
		}
		return round($dev_st*$f/sqrt(($n-1)),$precisione);
		
	}else{
		return NULL;
	}
}

function mini_max($dati){
	//con questa funzione devi usare i dati RIPULITI
	if(is_array($dati)){//verifico che sia un array, ridondante ma sempre meglio una verifica in pi
		$mi_ma=array();
		$mi_ma[0]=min($dati);//cerco il minimo
		$mi_ma[1]=max($dati);//cerco il massimo
		return $mi_ma;
	}else{
		return NULL;//altrimenti NULL
	}
}

function ora_min_max($dati, $tempo, $mi_max){
	//con questa funzione devi usare i dati ORIGINALI
	if(is_array($dati) && is_array($dati) && is_array($mi_max)){//devono essere entrambe array
		if(count($dati) == count($tempo)){// e dat e tempo delle stesse dimensioni
			$ora_mm=array();
			$n=count($dati);
			for($k=0;$k<$n;$k++){//cerco le ore della temperatura minima e massima
				if(preg_match( '/^[\-+]?[0-9]*\.*\,?[0-9]+$/', $dati[$k])){//salto l'eventuale dato anomalo
					if($mi_max[0]==$dati[$k]){//ora della temperatura minima
						$ora_mm[0]=$tempo[$k];
					}
					if($mi_max[1]==$dati[$k]){//ora della temperatura massimo
						$ora_mm[1]=$tempo[$k];
					}
				}
			}
			return $ora_mm;
		}else{
			return NULL;
		}
	}else{
		return NULL;
	}
}

function media_in_ore($dati, $tempo, $media){//$media  la media di dati
	//con questa funzione devi usare i dati ORIGINALI
	//talvolta pu dare risultati assurdi ma generalmente ci piglia
	if(is_array($dati) && is_array($tempo)){//devono essere entrambe array
		if(count($dati) == count($tempo)){// e delle stesse dimensioni
			$ora=array();//per intervallo orario
			$n=count($dati);
			for($k=0;$k<$n;$k++){
				if(preg_match( '/^[\-+]?[0-9]*\.*\,?[0-9]+$/', $dati[$k])){//salto l'eventuale dato anomalo
					if($media > $dati[$k]){$ora[0]=$tempo[$k];}
					if($media < $dati[$k]){$ora[1]=$tempo[$k];}
				}
			}
			//if($ora[0] > $ora[1]){$sc=$ora[0];$ora[0]=$ora[1];$ora[1]=$sc;}
			return $ora;
		}else{
			return NULL;//altrimenti NULL
		}
	}else{
		return NULL;//altrimenti NULL
	}
}
/*
qui la verifica del funzionamento delle funzioni presupposte che i dati del db siano gia stati trasformati in array
*/
$ora_originale=array('00:00','00:05','00:10','00:15','00:20','00:25','00:30','00:35');//hh:mm
$temp_originale=array(20.1,20.3,' ',20.8,21.6,20.0,21.0,21.9);
//con es di malfunzionamento alle ore 00:10
//stampo i dati originali
$num_o=count($ora_originale);
echo "---dati originali ($num_o)---<br>";
for($j=0; $j<$num_o;$j++){
	echo ($j+1).") ore ".$ora_originale[$j]." temperatura rilevata ".$temp_originale[$j]." C<br>";
}
$temp_r=pulisci($temp_originale);
$num_r=count($temp_r);
echo "<br>---dati TEMPERATURE ripulite ($num_r)---<br>";
for($j=0; $j<$num_r;$j++){
	echo ($j+1).") temperatura ripulite ".$temp_r[$j]." C<br>";
}
echo "<br>---dati sintetizzati---<br>";
//non ho messo i vari controlli se il return  NULL
$m=media($temp_r,2);
echo "temperatura media $m C<br>";
$ds=deviazione_standard($temp_r, $m,3);
echo "deviazione standard $ds C<br>";
$piu_meno=intervallo95($temp_r, $ds, 2);
echo "temperatura media $m &plusmn; $piu_meno C<br>";
$mm=mini_max($temp_r);
$ora_mm=ora_min_max($temp_originale, $ora_originale, $mm);
echo "temperatura minima $mm[0] ore $ora_mm[0] - temperatura massima $mm[1] ore $ora_mm[1]<br>";
$tra=media_in_ore($temp_originale, $ora_originale, $m);
echo "probabilmente la temperatura media ($m) risulta tra le ore $tra[0] e le ore $tra[1]<br>";
?>
